# Generated by Django 4.2.15 on 2024-09-03 16:42

from django.conf import settings
import django.contrib.postgres.indexes
import django.contrib.postgres.search
import django.core.serializers.json
from django.db import migrations, models
import django.db.models.deletion
import inboxen.validators


class Migration(migrations.Migration):

    replaces = [('inboxen', '0001_initial'), ('inboxen', '0002_remove_liberation_async_result'), ('inboxen', '0003_liberation_async_result'), ('inboxen', '0004_auto_20151025_1017'), ('inboxen', '0005_auto_20151025_1347'), ('inboxen', '0006_auto_20160424_0935'), ('inboxen', '0007_auto_20161002_1440'), ('inboxen', '0008_auto_20161018_1137'), ('inboxen', '0009_auto_20170518_1946'), ('inboxen', '0010_auto_20171204_1916'), ('inboxen', '0011_auto_20171231_1559'), ('inboxen', '0012_auto_20180313_0138'), ('inboxen', '0013_remove_userprofile_pool_amount'), ('inboxen', '0013_auto_20180508_1324'), ('inboxen', '0014_auto_20180511_2018'), ('inboxen', '0015_auto_20180512_0856'), ('inboxen', '0016_auto_20180513_1128'), ('inboxen', '0017_userprofile_display_images'), ('inboxen', '0018_auto_20180519_1811'), ('inboxen', '0019_auto_20180522_2025'), ('inboxen', '0020_userprofile_auto_delete'), ('inboxen', '0020_auto_20180531_1705'), ('inboxen', '0021_merge_20180601_1941'), ('inboxen', '0021_auto_20180607_2003'), ('inboxen', '0022_merge_20180607_2024'), ('inboxen', '0023_auto_20180522_2116'), ('inboxen', '0024_auto_20190225_1606'), ('inboxen', '0025_auto_20190304_1711'), ('inboxen', '0026_auto_20190501_2047'), ('inboxen', '0027_remove_body_size'), ('inboxen', '0028_userprofile_receiving_emails'), ('inboxen', '0029_alter_partlist_level_alter_partlist_lft_and_more'), ('inboxen', '0030_alter_partlist_options_remove_partlist_tree_id_and_more'), ('inboxen', '0031_alter_partlist_options'), ('inboxen', '0032_alter_statistic_emails_alter_statistic_inboxes_and_more'), ('inboxen', '0033_alter_liberation_user_alter_userprofile_user')]

    initial = True

    dependencies = [
        ("auth", "0012_alter_user_first_name_max_length"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Body",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "hashed",
                    models.CharField(
                        max_length=80,
                        unique=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("data", models.BinaryField(default=b"")),
            ],
        ),
        migrations.CreateModel(
            name="Domain",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "domain",
                    models.CharField(
                        max_length=253,
                        unique=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("enabled", models.BooleanField(default=True)),
                (
                    "owner",
                    models.ForeignKey(
                        blank=True,
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Email",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "search_tsv",
                    django.contrib.postgres.search.SearchVectorField(null=True),
                ),
                ("received_date", models.DateTimeField(db_index=True)),
                ("deleted", models.BooleanField(default=False)),
                ("read", models.BooleanField(default=False)),
                ("seen", models.BooleanField(default=False)),
                ("important", models.BooleanField(default=False)),
                ("view_all_headers", models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name="HeaderData",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "hashed",
                    models.CharField(
                        max_length=80,
                        unique=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                (
                    "data",
                    models.TextField(
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ]
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="HeaderName",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        max_length=78,
                        unique=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Liberation",
            fields=[
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        serialize=False,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                ("content_type", models.PositiveSmallIntegerField(default=0)),
                ("async_result", models.UUIDField(null=True)),
                ("started", models.DateTimeField(null=True)),
                ("last_finished", models.DateTimeField(null=True)),
                (
                    "_path",
                    models.CharField(
                        max_length=255,
                        null=True,
                        unique=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("running", models.BooleanField(default=False)),
                ("errored", models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name="Statistic",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "date",
                    models.DateTimeField(
                        auto_now_add=True, db_index=True, verbose_name="date"
                    ),
                ),
                (
                    "users",
                    models.JSONField(
                        encoder=django.core.serializers.json.DjangoJSONEncoder
                    ),
                ),
                (
                    "emails",
                    models.JSONField(
                        encoder=django.core.serializers.json.DjangoJSONEncoder
                    ),
                ),
                (
                    "inboxes",
                    models.JSONField(
                        encoder=django.core.serializers.json.DjangoJSONEncoder
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="UserProfile",
            fields=[
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        related_name="inboxenprofile",
                        serialize=False,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "prefer_html_email",
                    models.BooleanField(
                        default=True, verbose_name="Prefer HTML emails"
                    ),
                ),
                ("unified_has_new_messages", models.BooleanField(default=False)),
                (
                    "auto_delete",
                    models.BooleanField(
                        default=False,
                        help_text="Delete emails after 30 days. Emails that have been marked as important will not be deleted.",
                        verbose_name="Auto-delete emails",
                    ),
                ),
                (
                    "display_images",
                    models.PositiveSmallIntegerField(
                        choices=[
                            (0, "Always ask to display images"),
                            (1, "Always display images"),
                            (2, "Never display images"),
                        ],
                        default=0,
                        help_text="Warning: Images in HTML emails can be used to track if you read an email!",
                        verbose_name="Display options for HTML emails",
                    ),
                ),
                (
                    "quota_options",
                    models.PositiveSmallIntegerField(
                        choices=[(0, "Reject new emails"), (1, "Delete old emails")],
                        default=0,
                        verbose_name="What happens once your email quota is reached?",
                    ),
                ),
                ("quota_percent_usage", models.PositiveSmallIntegerField(default=0)),
                ("receiving_emails", models.BooleanField(default=True)),
                (
                    "prefered_domain",
                    models.ForeignKey(
                        blank=True,
                        help_text="Prefer a particular domain when adding a new Inbox",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="inboxen.domain",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="PartList",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("lft", models.PositiveIntegerField(db_index=True)),
                ("rght", models.PositiveIntegerField()),
                ("level", models.PositiveIntegerField()),
                (
                    "body",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT, to="inboxen.body"
                    ),
                ),
                (
                    "email",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="parts",
                        to="inboxen.email",
                    ),
                ),
                (
                    "parent",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="children",
                        to="inboxen.partlist",
                    ),
                ),
            ],
            options={
                "ordering": ["email", "lft"],
            },
        ),
        migrations.CreateModel(
            name="Inbox",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "search_tsv",
                    django.contrib.postgres.search.SearchVectorField(null=True),
                ),
                (
                    "inbox",
                    models.CharField(
                        max_length=64,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("created", models.DateTimeField(verbose_name="Created")),
                (
                    "description",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        validators=[
                            inboxen.validators.ProhibitNullCharactersValidator()
                        ],
                    ),
                ),
                ("deleted", models.BooleanField(default=False)),
                ("new", models.BooleanField(default=False)),
                (
                    "exclude_from_unified",
                    models.BooleanField(
                        default=False, verbose_name="Exclude from Unified Inbox"
                    ),
                ),
                (
                    "disabled",
                    models.BooleanField(
                        default=False,
                        help_text="This Inbox will no longer receive emails.",
                        verbose_name="Disable Inbox",
                    ),
                ),
                (
                    "pinned",
                    models.BooleanField(default=False, verbose_name="Pin Inbox to top"),
                ),
                (
                    "domain",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT, to="inboxen.domain"
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "Inboxes",
            },
        ),
        migrations.CreateModel(
            name="Header",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("ordinal", models.IntegerField()),
                (
                    "data",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="inboxen.headerdata",
                    ),
                ),
                (
                    "name",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="inboxen.headername",
                    ),
                ),
                (
                    "part",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="inboxen.partlist",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="email",
            name="inbox",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="inboxen.inbox"
            ),
        ),
        migrations.AddIndex(
            model_name="inbox",
            index=django.contrib.postgres.indexes.GinIndex(
                fields=["search_tsv"], name="inboxen_inb_search__0bbb83_gin"
            ),
        ),
        migrations.AlterUniqueTogether(
            name="inbox",
            unique_together={("inbox", "domain")},
        ),
        migrations.AddIndex(
            model_name="email",
            index=django.contrib.postgres.indexes.GinIndex(
                fields=["search_tsv"], name="inboxen_ema_search__5d822f_gin"
            ),
        ),
    ]
